class Embedding(Module):
  __parameters__ = []
  __buffers__ = []
  training : bool
  _is_full_backward_hook : Optional[bool]
  num_embeddings : int
  embedding_dim : int
  _packed_params : __torch__.torch.nn.quantized.modules.embedding_ops.EmbeddingPackedParams
  def forward(self: __torch__.torch.nn.quantized.modules.embedding_ops.Embedding,
    indices: Tensor) -> Tensor:
    _packed_params = self._packed_params
    _packed_weight = _packed_params._packed_weight
    _0 = ops.quantized.embedding_byte(_packed_weight, indices)
    return _0
class EmbeddingPackedParams(Module):
  __parameters__ = []
  __buffers__ = []
  training : bool
  _is_full_backward_hook : Optional[bool]
  dtype : int
  _packed_weight : __torch__.torch.classes.quantized.EmbeddingPackedParamsBase
  def forward(self: __torch__.torch.nn.quantized.modules.embedding_ops.EmbeddingPackedParams,
    x: Tensor) -> Tensor:
    return x
  def _weight(self: __torch__.torch.nn.quantized.modules.embedding_ops.EmbeddingPackedParams) -> Tensor:
    _1 = "Unsupported dtype for quantized embedding unpack! Supports quint8 and quint4x2."
    _2 = uninitialized(Tensor)
    dtype = self.dtype
    if torch.__contains__([13, 16], dtype):
      _packed_weight = self._packed_weight
      _4 = ops.quantized.embedding_bag_unpack(_packed_weight)
      _3 = _4
    else:
      ops.prim.RaiseException(_1)
      _3 = _2
    return _3
  def set_weight(self: __torch__.torch.nn.quantized.modules.embedding_ops.EmbeddingPackedParams,
    weight: Tensor) -> NoneType:
    _5 = "Unsupported dtype for quantized embedding prepack! Supports quint8 and quint4x2."
    dtype = self.dtype
    if torch.__contains__([13, 16], dtype):
      _6 = ops.quantized.embedding_bag_prepack(weight)
      self._packed_weight = _6
    else:
      ops.prim.RaiseException(_5)
    return None
